if(!$DataSaveBinding) {
	$remapDivision[$remapCount]="Data Save";
	$remapName[$remapCount]="Open Datasave";
	$remapCmd[$remapCount]="ToggleDatasaveGui";
	$remapCount++;
	$DataSaveBinding=1;
}
if(!isObject(DataSaveScrollProfile)) 
   new GuiControlProfile(DataSaveScrollProfile)
   {
      fontType = "Book Antiqua";
      fontSize = 22;
      justify = center;
      fontColor = "0 0 0";
      fontColorHL = "130 130 130";
      fontColorNA = "255 0 0";
      fontColors[0] = "0 0 0";
      fontColors[1] = "0 255 0";  
      fontColors[2] = "0 0 255"; 
      fontColors[3] = "255 255 0";
      hasBitmapArray = true;
      bitmap = "./scrollArray";
   };
if(!isObject(DataSaveContentBorderProfile))
   new GuiControlProfile(DataSaveContentBorderProfile : GuiBitmapBorderProfile){bitmap = "./contentArray";};
if(isObject(DataSave))
   DataSave.delete();
exec("./DataSave.gui");
function ToggleDatasaveGui(%a)
{
   if(DataSave.isAwake()&&%a)
   {
      canvas.popDialog(DataSave);
      DataSave.logPush("Closed GUI");
   }
   else if (%a)
   {
      canvas.pushDialog(DataSave);
      DataSave.logPush("Opened GUI");
      DataSave.loadDatablocks();
   }
}
if(isPackage(DatablockDetect))
   deactivatePackage(DatablockDetect);
package DatablockDetect
{
   function onPhase1Complete()
   {
      Parent::onPhase1Complete();
      if(isObject(%s=ServerConnection))%s.hasLoadedDatablocks=1;
   }
};
activatePackage(DatablockDetect);
function DataSave::loadDatablocks(%this)
{
   %this.logPush("Loading Datablocks");
   if(!isObject(ServerConnection))
   {
      %this.logPush("Load Interrupted - No server found");
      %this.listClear();
      return;
   }
   if(ServerConnection.getID() == %this.lastServer)
   {
      %this.logPush("Load Interrupted - Same Server");
      return;
   }
   if(getDatablockGroupSize()==0)
   {
      %this.logPush("Load Interrupted - No DataBlocks loaded");
      %this.listClear();
      return;
   }
   if(%this.hasLoadedBefore)
   {
      %this.logPush("Clearing Current Datablock List and Datablock Variables");
      %this.listClear();
      deleteVariables("%this.dataList*");
   }
   %a=%this.hasLoadedBefore;
   %this.hasLoadedBefore=1;
   %this.lastServer=ServerConnection.getID();
   %this.logPush("Starting Datablock Load");
   %this.logPush("Found "@getDataBlockGroupSize()@" DataBlocks.");
   %c=0;
   for(%i=0;%i<getDataBlockGroupSize();%i++)
   {
      %d=getDataBlock(%i);
      %u=%d.uiname;
      if(strLen(%u))
      {
         %this.listPush(%c+1@") "@%d.getClassName()@" - "@%u);
         %this.dataList["UI",%c]=%u;
         %this.dataList["DB",%c]=%d;
         %c++;
      }
   }
   %this.dataListCount=%c;
   %this.logPush("Grabbed "@%c+1@"/"@getDatablockGroupSize()@" usable Datablocks");
   if(!%a)
   {
      %this.logPush("!!!-------------INFORMATION--------------!!!");
      %this.logPush("To Download:");
      %this.logPush("Double click a Datablock to download a Datablock");
      %this.logPush("Note:");
      %this.logPush("Not all datablocks can be downloaded");
      %this.logPush("All DataBlocks Downloaded will be saved under \"config/DataBlockSaver/~\"");
      %this.logPush("Any DataBlocks sharing Names will be overWritten");
      %this.logPush("You might not have the files required to use these datablocks as is.");
   }
}
function DataSave::grabDatablock(%this,%d)
{
   if(!strLen(%d))
   {
      %this.logPush("Unable to save - No Datablock selected");
      return;
   }
   %d--;
   %this.logPush("Attempting to Save DataBlock \""@%this.dataList["UI",%d]@"\"");
   if(!isObject(ServerConnection))
   {
      %this.logPush("Save Interrupted - No server found");
      %this.listClear();
      return;
   }
   if(getDatablockGroupSize()==0)
   {
      %this.logPush("Save Interrupted - No DataBlocks loaded");
      %this.listClear();
      return;
   }
   if(!%this.hasLoadedBefore)
   {
      %this.logPush("Clearing Current Datablock List and Datablock Variables");
      %this.listClear();
      return;
   }
   %db=%this.dataList["DB",%d];
   %ui=%this.dataList["UI",%d];
   if(isFile("config/DataBlockSaver/"@%ui@".txt"))
   {
      %this.logPush("\"config/DataBlockSaver/"@%ui@".txt\" Already Exists - OverWriting");
      fileDelete("config/DataBlockSaver/"@%ui@".txt");
   }
   %this.logPush("Saving "@%db@" - \""@%ui@"\"");
   %db.save("config/DataBlockSaver/"@%ui@".txt");
   if(isFile("config/DataBlockSaver/"@%ui@".txt"))
      %this.logPush("Saved Datablock "@%ui);
   else
      %this.logPush("Could not save Datablock "@%ui);
}
function DataSave::listPush(%this,%s)
{
   Data_List.addRow(%this.ListRowCount++,%s);
}
function DataSave::listClear(%this)
{
   Data_List.clear();
   %this.ListLineCount=-1;
}
function DataSave::logPush(%this,%s)
{
   Data_Log.addRow(%this.LogRowCount++,%s);
   Data_LogScroll.scrollToBottom();
}
DataSave.logPush("DataBlock Saver");
DataSave.logPush("Author: MARBLE MAN");
DataSave.logPush("BL_ID: 10103");
DataSave.logPush("---------------");